﻿--Portrait Timers v1.0
-- Buff/Debuff monitor for target and party
-- Written by Killakhan
-- http://www.wowinterface.com/downloads/author-259436.html

local PortraitTimers = {}
local addon = PortraitTimers
local version = "1.0"
local addonName = "PT"
PortraitTimersDB = {
	fontSize = "Normal",
}
addon.fontsDB = {
	["Normal"] = "GameFontNormalLarge",
	["Small"] = "GameFontNormal",
	["Large"] = "GameFontNormalHuge",
}

addon.spellDB = {
   
	-- Higher up = higher display prio
	
	-- immunitys
	"45438", -- Ice Block
	"33786", -- Cyclone
	"642", -- Divine Shield
	"1022", -- Hand of Protection
	"19263", -- Deterrence
	"46924", -- Bladestorm

	-- stuns
	"408", -- Kidney Shot
	"1833", -- Cheap Shot
	"12809", -- Concussion Blow
	"46968", -- Shockwave
	"853", -- Hammer of Justice
	"49203", -- Hungering Cold
	"85388", -- Throwdown
	"44572", -- Deep Freeze
	"5211", -- Bash
	"19503", -- Scatter Shot
	"30283", -- Shadowfury
	"89605", -- Aura of Foreboding
	"89766", -- Axe Toss
	"22570", -- Maim
	"9005", -- Pounce
	"47481", -- Gnaw
	"1776", -- Gouge
	"6770", -- Sap
	"87195", -- Paralysis
	   
	--cc
	"605", -- Mind Control
	"64044", -- Psychic Horror
	"2094", -- Blind
	"118", -- Polymorph
	"51514", -- Hex
	"6789", -- Death Coil
	"5246", -- Intimidating Shout 
	"8122", -- Psychic Scream
	"5484", -- Howl of Terror
	"5782", -- Fear
	"6358", -- Seduction
	"1499", -- Freezing Trap
	"20066", -- Repentance
	"339", -- Entangling Roots
	"8377", -- Earthgrab
	"31661", -- Dragon's Breath
	"16689", -- Nature's Grasp
	"82691", -- Ring of Frost
   
	-- cc immune
	"53271", -- Master's Call
	"1044", -- Hand of Freedom
	"31224", -- Cloak of Shadows
	"51271", -- Pillar of Frost
	
	-- dmg reductions
	"48707", -- Anti-Magic Shell
	"30823", -- Shamanistic Rage 
	"33206", -- Pain Suppression
	"47585", -- Dispersion
	"871", -- Shield Wall
	"48792", -- Icebound Fortitude
	"498", -- Divine Protection
	"22812", -- Barkskin
	"61336", -- Survival Instincts	
	"5277", -- Evasion
   
	-- silences
	"47476", -- Strangulate
	"55021", -- Silenced - Improved Counterspell
	"15487", -- Silence
	"19647", -- Spell Lock
	"34490", -- Silencing Shot
	"28730", -- Arcane Torrent
	
	-- disarms
	"676", -- Disarm
	"51722", -- Dismantle
	
	--dmg buffs  
	"34692", -- The Beast Within
	"31884", -- Avenging Wrath
  
	--helpful buff
	"68992", -- Darkflight (Worgen racial)
	"31642", -- Blazing Speed
	"54428", -- Divine Plea
	"2983", -- Sprint
	"1850", -- Dash
	"29166", -- Innervate
}

addon.f = CreateFrame("Frame", addonName.."mainFrame", UIParent)

-- main update frames
addon.TargetFrame = CreateFrame("Frame", addonName.."_TargetFrame", UIParent)
local tFrame = addon.TargetFrame
tFrame:SetWidth(1)
tFrame:SetHeight(1)
tFrame:SetFrameStrata("DIALOG")
addon.FocusFrame = CreateFrame("Frame", addonName.."_FocusFrame", UIParent)
local fFrame = addon.FocusFrame
fFrame:SetWidth(1)
fFrame:SetHeight(1)
fFrame:SetFrameStrata("DIALOG")

addon.f:SetScript("OnEvent", function(self, event, ...) 
      if addon[event] then 
         return addon[event](addon, event, ...) 
      end 
end)

-- register events
addon.f:RegisterEvent("PLAYER_LOGIN")
addon.f:RegisterEvent("PLAYER_ENTERING_WORLD")
addon.f:RegisterEvent("ADDON_LOADED")

-- event functions
function addon:PLAYER_ENTERING_WORLD(event, ...)
	local _, instance = IsInInstance()
	if instance == "raid" then
		addon.f:UnregisterEvent("UNIT_AURA")
		addon.f:UnregisterEvent("PLAYER_TARGET_CHANGED")
		addon.f:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		tFrame:SetScript("OnUpdate", nil)
		tFrame:Hide()
		fFrame:SetScript("OnUpdate", nil)
		fFrame:Hide()
	else
		addon.f:RegisterEvent("UNIT_AURA")      
		addon.f:RegisterEvent("PLAYER_TARGET_CHANGED")
		addon.f:RegisterEvent("PLAYER_FOCUS_CHANGED")
	end
	
	if addon.XPerl_loaded then -- XPerl
		if XPerl_Target.conf.portrait3D == 1 then -- name, portrait, parent, frame
			self.CreateAuraIcons(addonName.."TargetTexture", XPerl_TargetportraitFrame.portrait, XPerl_TargetportraitFrameportrait3D, tFrame)
		else
			self.CreateAuraIcons(addonName.."TargetTexture", XPerl_TargetportraitFrame.portrait, XPerl_TargetportraitFrame, tFrame)
		end
		if XPerl_Focus.conf.portrait3D == 1 then
			self.CreateAuraIcons(addonName.."FocusTexture", XPerl_FocusportraitFrame.portrait, XPerl_FocusportraitFrameportrait3D, fFrame)
		else
			self.CreateAuraIcons(addonName.."FocusTexture", XPerl_FocusportraitFrame.portrait, XPerl_FocusportraitFrame, fFrame)
		end
	elseif addon.PitBull_Loaded then
		return
	else
		self.CreateAuraIcons(addonName.."TargetTexture", TargetFramePortrait, TargetFrame, tFrame)
		self.CreateAuraIcons(addonName.."FocusTexture", FocusFramePortrait, FocusFrame, fFrame)
	
	end
end

function addon:UNIT_AURA(event, unit)
	if unit == "target" or unit == "focus" then
		addon.CheckAura(unit)
	end
end

function addon:PLAYER_TARGET_CHANGED(event)
	if UnitExists("target") then
		-- print("target exists, check aura")
		if addon.PitBull_Loaded then
			if not tFrame.auraIcon then
				-- print("create icon target")
				self.CreateAuraIcons(addonName.."TargetTexture", PitBull4_Frames_target.Portrait, PitBull4_Frames_target.Portrait, tFrame)
			else
			tFrame.auraIcon:SetAllPoints(PitBull4_Frames_target.Portrait)
			-- print("already created target icon")
			end
		end
		addon.CheckAura("target")
	else
		tFrame:Hide()
	end
end
function addon:PLAYER_FOCUS_CHANGED(event)
	if UnitExists("focus") then
		if addon.PitBull_Loaded then
			if not fFrame.auraIcon then
				self.CreateAuraIcons(addonName.."FocusTexture", PitBull4_Frames_focus.Portrait, PitBull4_Frames_focus.Portrait, fFrame)
			end
			fFrame.auraIcon:SetAllPoints(PitBull4_Frames_focus.Portrait)
		end
		addon.CheckAura("focus")
	else
		fFrame:Hide()
	end
end

function addon:ADDON_LOADED(event, addon)
	if addon == "PortraitTimers" then
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |rPortrait Timers v"..version.." Loaded")
		self.CreateConfig()
		UIDropDownMenu_SetText(self.dropdown1, PortraitTimersDB.fontSize)
		self.f:UnregisterEvent("ADDON_LOADED")
	end
end

function addon:PLAYER_LOGIN(event)
	if IsAddOnLoaded("AuraTimers")  then
		self.AT_loaded = true
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |c00FF0000Error!|r You must remove any previous versions of AuraTimers before installing PortraitTimers!")
		return
	end
	if IsAddOnLoaded("PitBull4") then
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |rPitBull4 Detected.")
		self.PitBull_Loaded = true
	end
	if IsAddOnLoaded("XPerl") then
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |rXPerl Detected.")
		self.XPerl_loaded = true
	end
end

-- other functions

function addon.CreateAuraIcons(name, portrait, parent, frame)
	if frame.auraIcon then return end
	frame.auraIcon = parent:CreateTexture(name, "OVERlAY")
	frame.auraIcon:SetPoint("CENTER", portrait)
	if not frame.font then
		addon.CreateFontStrings(name .. "_Font", frame)
	end
	-- print("Created " .. frame.font:GetName())
end

function addon.CreateFontStrings(name, frame)
	local fontString
	for k, v in pairs(addon.fontsDB) do
		if k == PortraitTimersDB.fontSize then
			-- print(k, v)
			fontString = v
		end
	end
	frame.font = frame:CreateFontString(name, "OVERLAY")
	frame.font:SetPoint("CENTER", frame.auraIcon, "CENTER")
	frame.font:SetFontObject(fontString)
	frame.font:SetText("")
	frame.font:SetTextColor(1, 1, 1)
	-- print("Created " .. frame.font:GetName())
end

function addon.SetFontSize(font)
	tFrame.font:SetFontObject(font)
	fFrame.font:SetFontObject(font)
end

function addon.HideAll(unit)
	local frame
	-- print("hide: " .. unit)
	if unit == "target" then
		frame = tFrame 
	elseif unit == "focus" then
		frame = fFrame
	end
	frame:Hide()
	frame.auraIcon:Hide()
	frame.font:SetText("")
end

function addon.CheckAura(unit)
	-- print("check aura " .. unit)
	for idx, spellID in ipairs(addon.spellDB) do
		local spell = GetSpellInfo(spellID)
		if UnitBuff(unit, spell) then
			local _, _, texture, _, _, _, eTime = UnitBuff(unit, spell)
			addon.SetAura(unit, texture, eTime)
			-- print("found buff " .. spell)
			return
		elseif UnitDebuff(unit, spell) then
			local _, _, texture, _, _, _, eTime = UnitDebuff(unit, spell)
			addon.SetAura(unit, texture, eTime)
			-- print("found debuff " .. spell)
			return
		end
	end
	-- print("found no auras")
	addon.HideAll(unit)
end

function addon.SetPortraitTexture(frame, texture)
	if not frame then return end
	if addon.PitBull_Loaded then
		frame.auraIcon:SetTexture(texture)
		frame.auraIcon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	elseif addon.XPerl_loaded then
		frame.auraIcon:SetTexture(texture)
	else
		SetPortraitToTexture(frame.auraIcon, texture)
	end
end

function addon.SetAura(unit, texture, eTime)
	local frame, portraitFrame
	if unit == "target" then
		frame = tFrame
	elseif unit == "focus" then
		frame = fFrame
	end	
	addon.SetPortraitTexture(frame, texture)
	frame.texture = texture
	frame.font:SetText(string.format("%.1f", eTime-GetTime()))
	frame.eTime = eTime
	frame.name = unit
	frame:Show()
	frame.auraIcon:Show()
	frame:SetScript("OnUpdate", addon.UpdateTimer)
end

local total = 0.1
function addon.UpdateTimer(self, elapsed)
	total = total + elapsed
	if total >= 0.1 then 
		if self.eTime - GetTime() > 0 and UnitExists(self.name) and self:IsVisible() then
			addon.SetPortraitTexture(self, self.texture)	
			self.font:SetText(string.format("%.1f", self.eTime-GetTime()))
			total = 0
		else
			-- print("reached 0, stopping update")
			addon.HideAll(self.name)
		end
	end
end


-- config
function addon.CreateConfig()

	addon.panel = CreateFrame("Frame", addonName.."panel", UIParent)
	addon.panel.name = "PortraitTimers"
	InterfaceOptions_AddCategory(addon.panel)

	addon.title = addon.panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	addon.title:SetPoint("TOPLEFT", 16, -16)
	addon.title:SetText("PortraitTimers Config")

	addon.subtitle = addon.panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	addon.subtitle:SetPoint("TOPLEFT", addon.title, "BOTTOMLEFT", 0, -8)
	addon.subtitle:SetNonSpaceWrap(true)
	addon.subtitle:SetText("v"..version)
	addon.subtitle:SetTextColor(1, 1, 1, 0.5)

	addon.dropdown1 = CreateFrame("Frame", addonName.."dropdown1", addon.panel, "UIDropDownMenuTemplate")
	addon.dropdown1:SetPoint("TOPLEFT", addon.subtitle, "BOTTOMLEFT", -10, -30)
	addon.dropdown1:SetWidth(40)
	addon.dropdown1.font = addon.dropdown1:CreateFontString(addonName.."dropdownFont", "ARTWORK", "GameFontNormalSmall")
	addon.dropdown1.font:SetPoint("BOTTOMLEFT", addon.dropdown1, "TOPLEFT", 20, 0)
	addon.dropdown1.font:SetText("Font Size:")
	_G[addon.dropdown1:GetName().."Button"]:SetScript("OnClick", function(self, button, down)
		  ToggleDropDownMenu(1, nil, addon.dropdown1, self:GetName(), -100 ,0)
	end)

	local info = {}

	function addon.dropdown1.initialize(self, level)
		if not level then return end
		wipe(info)
		if level == 1 then
			addon.CreateMenu(info)
		end
	end

	function addon.OnClickFunc(button, arg1, arg2, checked)
		PortraitTimersDB.fontSize = arg1
		addon.SetFontSize(arg2)
		-- print("selected " .. arg1, arg2)
		UIDropDownMenu_SetText(addon.dropdown1, arg1)
	end	
		
	function addon.CreateMenu(info)
		for k, v in pairs(addon.fontsDB) do
			info.text = k
			info.isTitle = nil
			info.notCheckable = nil
			info.func = addon.OnClickFunc
			info.arg1 = k
			info.arg2 = v
			info.fontObject = addon[k]
			info.checked = addon.isCurrent(k)
			UIDropDownMenu_AddButton(info)
		end
	end	

	function addon.isCurrent(font)
		if PortraitTimersDB.fontSize == font then
			return true
		else
			return false
		end
	end
end